# Single Tx Profile Setup

## Create and deploy new project

Create a new BackedBy protocol project in one transaction.  This does not register with the Backed.By platform but can be completed there.

```solidity
// SPDX-License-Identifier: MIT
pragma solidity ^0.8.17;

import "IBBProfiles.sol";
import "IBBTiers.sol";
import "IBBSubscriptionsFactory.sol";

contract BBProfileSetup {
    constructor(
        IBBProfiles bbProfiles,
        IBBTiers bbTiers,
        IBBSubscriptionsFactory bbSubFactory,
        string memory profileCid,
        uint256[] memory tierPrices,
        string[] memory tierCids,
        bool[] memory tierDeprecated,
        uint256 contribution
    ) {
        uint256 profileId = _bbProfiles.createProfile(
            address(this),
            address(this),
            profileCid
        );
        uint256 tierSetId = _bbTiers.createTiers(
            profileId,
            tierPrices,
            tierCids,
            tierDeprecated,
            _defaultCurrencies,
            _defaultMul
        );

        _bbSubFactory.createSubscriptionProfile(
            profileId,
            tierSetId,
            contribution
        );

        _bbProfiles.editProfile(profileId, msg.sender, msg.sender, profileCid);
    }
}

```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.backed.by/docs/developers/example-contracts/single-tx-profile-setup.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
